#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ioctl.h>

#include <modbus.h>


typedef struct {
	  u_int32_t voltage;
	  u_int32_t current;
	  u_int32_t power_active;
	  u_int32_t power_reactive;
	  u_int32_t power_apparent;
	  u_int32_t energy_pos_active;
	  u_int32_t energy_pos_reactive;
	  u_int32_t energy_neg_active;
	  u_int32_t energy_neg_reative;
	  u_int16_t frequency;
	  u_int16_t run_time;
	  u_int16_t power_factor;
	  u_int8_t	power_factor_sector;
	  u_int8_t	active_power_sign;
	  u_int8_t	reactive_power_sign;
	  u_int32_t average_power;
	  u_int32_t peak_maximum_demand;
	  u_int8_t	average_power_time;
	  u_int16_t	THD_V1;
	  u_int16_t THD_I1;
	  u_int32_t current_I1_avg;
	  u_int32_t current_I1_peak_max;
	  u_int32_t V1_min;
	  u_int32_t V1_max;

	}meter_data_str;

	typedef struct {
		  u_int16_t ct_ratio;
		  u_int16_t vt_ratio;
		  u_int32_t nemo_config;
		  u_int8_t device_id;

		}meter_status_str;

void meter_value_data_reset (meter_data_str *p_meter_data)
{
	memset (p_meter_data, 0, sizeof (meter_data_str));
}

void meter_status_data_reset (meter_status_str *p_meter_status)
{
	memset (p_meter_status, 0, sizeof (meter_status_str));
}

const u_int32_t READ_BUFFER_LENGTH=50;


int main(void) {


	puts("Hello World"); /* prints Hello World */
	/**
	 * author james
	 *  Set up meter data structures
	 */
	meter_data_str meter_data;
	meter_status_str meter_status;

	/**
			 * author james
			 *  Set up modbus data structures
			 */

	modbus_t *modbus_str;
	u_int16_t modbus_buff [READ_BUFFER_LENGTH * sizeof (u_int16_t)];
	u_int32_t rc;
	u_int16_t i;

	memset (modbus_buff, 0, sizeof (modbus_buff));

	meter_value_data_reset(&meter_data);
	meter_status_data_reset(&meter_status);

	modbus_str = modbus_new_rtu("/dev/ttys5", 19200, 'N', 8, 1);
	        modbus_set_slave(modbus_str, 1);
	        rc= modbus_read_input_registers(modbus_str,READ_BUFFER_LENGTH,0x301,modbus_buff);

	        if (rc == -1) {
	            printf ("error");
	            return -1;
	        }

	        for (i=0; i < rc; i++) {
	            printf("reg[%d]=%d (0x%X)\n", i, modbus_buff[i], modbus_buff[i]);
	        }






	modbus_close(modbus_str);
	modbus_free(modbus_str);

	return EXIT_SUCCESS;
}
